#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>


struct hostent 		*hp_mirror;
struct sockaddr_in 	sa1,sa2;

#define MAX(a,b)	(((a)>=(b))?(a):(b))

char *client = "client.log";
char *server = "server.log";

int 	MYPORT;	
int 	EXTPORT;
char 	name[200];	


int checkargs(int argc, char **argv, char *allopts)
{
	static int c,n,l,r;
	extern char *optarg;
	extern int optind;
	n=l=r=0;
	if (argc!=4) return (-1);

	while ((c = getopt(argc, argv, allopts)) != -1)
	switch(c){
	case 'n':
		strcpy(name,optarg);
		n=1;
		break;
	case 'l':
		MYPORT = atoi(optarg);
		l=1;
		break;
	case 'r':
		EXTPORT = atoi(optarg);
		r=1;
		break;
	}
		
	if ((n+l+r)!=3) return (-1); else return (0);
}


char *b2ip(unsigned char *bo)
{
	static char ipbuf[15];
	sprintf(ipbuf,"%u.%u.%u.%u",bo[0],bo[1],bo[2],bo[3]);
	return (ipbuf);
}


/* 
 * Ja, was macht denn mein Kind :-)
 */
void sigchld (int sig)
{
	while (waitpid(-1,NULL,WNOHANG) > 0);
	signal (SIGCHLD, sigchld);
}

int main(int argc, char **argv)
{
	int 	s1, s2, ns;
	int 	pid, rb, ok;
	char 	abuf[1513];
	fd_set 	fds;
	struct 	timeval tv;
	int 	retval,smax;
	FILE 	*fs, *fc;

	tv.tv_sec = 1;
	tv.tv_usec = 0;

	ok = checkargs(argc, argv, "n:l:r:");

	if (ok!=0) {
		printf("\nusage: %s -n<server> -l<localport> -r<remoteport>\n\r",argv[0]);
		exit(1);
	}

	/*
	 * Initialisierung der eigenen Hostdaten 
	 */
	bzero(&sa1, sizeof(sa1));
	sa1.sin_family 		= AF_INET;
	sa1.sin_port 		= htons(MYPORT);

	/* 
	 * Initialisierung der zu spiegelnden Hostdaten 
	 */
	hp_mirror = gethostbyname(name);
	bzero(&sa2, sizeof(sa2));
	bcopy(&hp_mirror->h_addr,&sa2.sin_addr,hp_mirror->h_length);
	sa2.sin_family 	= hp_mirror->h_addrtype;
	sa2.sin_port 	= htons(EXTPORT);
	sa2.sin_addr.s_addr = inet_addr(b2ip( hp_mirror->h_addr));

	/* 
	 * Bereitstellung des 'Horch'-Sockets
	 */
	if ((s1 = socket(AF_INET,SOCK_STREAM,IPPROTO_IP)) == -1) {
		perror("socket1");
		exit (1);
	} 

	/* 
	 * Binden des 'Horch'-Sockets an meine Adresse
	 */
	if (bind(s1, (struct sockaddr *)&sa1, sizeof(sa1)) == -1) {
		perror("bind");
		exit (2);
	} 

	if (listen(s1,5) == -1) {
		perror("listen");
		exit (3);
	}

	signal (SIGCHLD, sigchld);

	/* 
	 * Warten auf's Christkind
	 */
	while (1)
	{
		if ((ns = accept(s1,0,0)) == -1) {
			if (errno == EINTR) continue;
			perror("accept");
			exit (4);
		}

		if ((pid = fork()) == -1) {
			perror("fork");
			exit (5);
		}
		if (pid == 0)
			break;
		close(ns);
	}

	/* 
	 * Wenn jemand was von mir will...
	 */
	if ((s2 = socket(AF_INET,SOCK_STREAM,IPPROTO_IP))== -1) {
		perror("socket");
		exit(6);
	} else ok = connect(s2, (struct sockaddr *)&sa2, sizeof(sa2));

    /*
	fc = fopen(client, "w");
	fs = fopen(server, "w");
	*/

	smax = MAX(s2,ns) +1;
	while (1) {
		FD_ZERO(&fds);
		FD_SET(ns,&fds);
		FD_SET(s2,&fds);
		/* 
		 * Wir stellen uns den Wecker...
		 */
		retval = select(smax,&fds,NULL,NULL,NULL);
		if (retval<0)
		{
			if (errno == EINTR) continue;
			perror("select");
			exit (1);
		}
		if (FD_ISSET(ns,&fds)) {
			/* lese von lokalem client */
			rb = read(ns,abuf,sizeof(abuf)); 
			if (rb==0) break;
			else if (rb < 0)
			{
				if (errno == EINTR) continue;
				exit (1);
			}
			write(s2,abuf,rb);
			/*
			fprintf(fc, "%s", abuf);
			fflush(fc);
			*/
		}
		if (FD_ISSET(s2,&fds)) {
			/* lese von fremdhost */
			rb = read(s2,abuf,sizeof(abuf)); 
			if (rb==0) break;
			else if (rb < 0)
			{
				if (errno == EINTR) continue;
				exit (1);
			}
			write(ns,abuf,rb);
			/*
			fprintf(fs, "%s", abuf);
			fflush(fs);
			*/
		}
	}

	close(s2);
	close(ns);
	fclose(fc);
	fclose(fs);
	return (0);
}
